Program DriverDemo4A23;
uses dos;
{$I 8259 }
{$I HREAD }
{$I 4A23LOW }
{$I 4A23DLOW}
{$I 4A23DFUN}
{$I general}

type
DPtrRec = record
           Ofs : word;
           Smt : word;
         end;
var
IntRec : IntRecType;
IntRecPtr : ^IntRecType;
AToDRecPtr : AToDRecPtrType;
CalibRecPtr : CalRecPtrType;
DriverInt : byte;

procedure BumOut(s: string);
begin
  writeln;
  writeln(s);
  halt(2);
end;

procedure CallDriverInt(intno: byte;p :pointer);
begin
  asm
    mov al,intno             { bad bad old nasty self modifying code ! }
    lea bx,@intbyte
    mov cs:[bx],al
    mov cx,DPtrRec[p].Smt
    mov bx,DPtrRec[p].Ofs
    jmp @intins              { we hope this dumps the queue! }
    @intins:
    db $cd
    @IntByte:
    db $00
  end;
end;

function DriverInstalledQ : boolean;
begin
  IntRec.FunctionNum := DRFuncGetVersion;
  IntRec.ErrorCode := ErrorCodeBad;
  CallDriverInt(DriverInt,IntRecPtr);
  if IntRec.ErrorCode = ErrorCodeOK then
  if IntRec.Data = GetD4A23Version then
  DriverInstalledQ := true else DriverInstalledQ := false;
end;

function StartConversions : boolean;
begin
  IntRec.FunctionNum := DRFuncStartConversions;
  IntRec.ErrorCode := ErrorCodeBad;
  CallDriverInt(DriverInt,IntRecPtr);
  if IntRec.ErrorCode = ErrorCodeOK
  then StartConversions := true
  else StartConversions := false;
end;

function StopConversions : boolean;
begin
  IntRec.FunctionNum := DRFuncStopConversions;
  IntRec.ErrorCode := ErrorCodeBad;
  CallDriverInt(DriverInt,IntRecPtr);
  if IntRec.ErrorCode = ErrorCodeOK
  then StopConversions := true
  else StopConversions := false
end;

function GetAtoDRecPtr : pointer;
begin
  IntRec.FunctionNum := DRFuncGetAtoDRecPtr;
  IntRec.ErrorCode := ErrorCodeBad;
  CallDriverInt(DriverInt,IntRecPtr);
  GetAToDRecPtr := IntRec.Pointer;
end;

function GetCalibRecPtr : pointer;
begin
  IntRec.FunctionNum := DRFuncGetCalibRecPtr;
  IntRec.ErrorCode := ErrorCodeBad;
  CallDriverInt(DriverInt,IntRecPtr);
  GetCalibRecPtr := IntRec.Pointer;
end;

function GetScanCount : longint;
begin
  IntRec.FunctionNum := DRFuncGetScanCount;
  IntRec.ErrorCode := ErrorCodeBad;
  CallDriverInt(DriverInt,IntRecPtr);
  GetScanCount := IntRec.Data;
end;

function GetFIFOData : boolean;
begin
  IntRec.FunctionNum := DRFuncGetFIFOData;
  IntRec.ErrorCode := ErrorCodeBad;
  CallDriverInt(DriverInt,IntRecPtr);
  if IntRec.ErrorCode = ErrorCodeOK
  then GetFIFOData := true
  else GetFIFOData := false;
end;

function FIFOHasDataQ : boolean;
begin
  IntRec.FunctionNum := DRFuncGetFIFODataStatus;
  IntRec.ErrorCode := ErrorCodeBad;
  IntRec.Status := STFalse;
  CallDriverInt(DriverInt,IntRecPtr);
  if IntRec.Status = StTrue
  then FIFOHasDataQ := true
  else FIFOHasDataQ := false;
end;

procedure ReadLoop;

{ This is a data driven display loop - channel numbers extracted }
{ from FIFO determine where data is displayed }
var
showx,showy,nd : byte;
rs : string;
realdata : real;
begin  {readloop}
  {ClrScr;}
  if StartConversions then;
  while not keypressed do
  begin
    if FIFOHasDataQ then
    begin
      if GetFIFOData then;
      with IntRec do
      begin
        showx := ((Channel div 8) * 24) +1;
        showy := (Channel mod 8) +1;
        if (Channel <> TempChannel) then
        begin
          realdata := AsVolts(Data,Range);
          writeln('Chan',Channel:2,'=',realdata:1:6,'    sc=',GetScanCount);
        end
        else
        begin
          realdata := AsTemp(Data,CalibRecPtr);
          writeln('Temp=',realdata:3:4,'    sc=',GetScanCount);
        end;
      end; {with IntRec }
    end; {if FIFOHasData }
  end; {while not keypressed}
  if StopConversions then;
end;

function GetParms : boolean;
var
wtemp : word;
begin
  GetParms := false;
  if not HexWordRead(ParamStr(1),wtemp) then BumOut('Undecipherable software interrupt number');
  if (wtemp < $60) or (wtemp > $6F) then BumOut('Out of range software interrupt number');
  if not IntNullPtrQ(byte(wtemp)) then
  begin
    DriverInt := byte(wtemp);
    if not DriverInstalledQ then BumOut('4A23 driver not found!');
    GetParms := true;
  end
  else
  begin
    Bumout('4A23 driver not found!');
  end;
end;

procedure Usage;
begin
  writeln;
  writeln('USAGE: 4A23DRDM SOFT');
  writeln;
  writeln('PURPOSE: Demonstrates 4A23 driver usage');
  writeln;
  writeln('Where SOFT is the (hex) software interrupt the driver uses');
  writeln;
  halt(2);
end;

begin                  { main }
  {DirectVideo := false;}
  IntRecPtr := @IntRec;
  if GetParms then
  begin
    AtoDRecPtr := GetAtoDRecPtr;
    CalibRecPtr := GetCalibRecPtr;
    writeln('Seal = ',AtoDRecPtr^.AtoDRecSeal);
    if AtoDRecPtr^.AtoDRecSeal <> RoseBud then
    begin
      writeln('AtoDRecord Seal should be ',Rosebud,' but is ',AtoDRecPtr^.AtoDRecSeal);
      Bumout('4A23 driver has not been configured');

    end;
    if StopConversions then ReadLoop
    else
    begin
      writeln('Shouldn''t...');
    end;
  end
  else Usage;
end.
