program ATODPOLL;
{$DEFINE main}
{$I hprint}
{$I 4A23LOW.PAS}
{$I general}

var
Chan : byte;
ADData : longint;
PrintData : real;
FooKey : word;
CalibRec : CalibRecordType;

procedure DoReading(chan : byte;range: longint);
begin
  SetChannel(chan);
  SetRangeAndCal(range,@CalibRec);
  if PolledReadADWithStatus(ADData) then
  begin
    PrintData := ADData*(FSFromRange(range)/FullScaleReal);
    if (range = ADRange5V) or (range = ADRange2r5V) or (range = ADRange1V) then
    begin
      write(PrintData:1:6);
      writeln('V ');
    end
    else
    begin
      write(PrintData*1000:2:5);
      writeln('mV ');
    end;
  end
  else writeln('Conversion failed');
end;

begin
  BasePort := A23BaseAdd0;
  if not Init4A23 then
  begin
    writeln('4A23 wont init!');
    halt(2);
  end;
  writeln('4A23 initialized OK!');
  if ReadCalData(@CalibRec) then
  begin
    SetInputSource(Normal);
    SetConvRate(ADWordRate3r76);
    SetRangeAndCal(ADRange5V,@CalibRec);
    {do dummy read}
    ADData := PolledReadAD;
    while not KeyPressed do
    begin
      for Chan := 0 to LastChannel do DoReading(Chan,ADRange5V);
    end;
  end
  else writeln('Failed to read calibrate EEPROM');
end.
