const

{ Max CS5526 command register bits }

ADCommandBit        = $80;
ADSingleConvBit     = $40;
ADContConvBit       = $20;
ADReadBit           = $10;
ADPowerDwnBit       = $01;

{ Register selects in command Reg }

ADOffsetRegSel      = $00;
ADGainRegSel        = $02;
ADConfigRegSel      = $04;
ADDataRegSel        = $06;
ADSetpUpRegSel      = $08;

{ Some common commands }

ReadADDataCom       = ADCommandBit or ADReadBit or ADDataRegSel;
ReadConfigCom       = ADCommandBit or ADReadBit or ADConfigRegSel;
ReadOffsetCom       = ADCommandBit or ADReadBit or ADOffsetRegSel;
ReadGainCom         = ADCommandBit or ADReadBit or ADGainRegSel;
WriteConfigCom      = ADCommandBit or ADConfigRegSel;
WriteOffsetCom      = ADCommandBit or ADOffsetRegSel;
WriteGainCom        = ADCommandBit or ADGainRegSel;
SingleConvertCom    = ADCommandBit or ADSingleConvBit;
ContConvertCom      = ADCommandBit or ADContConvBit;


{ CS5526 configuration register bits }

ADChopFS         = $40000;
ADLowPwrMode     = $10000;
{ Note that these word rates are with normal speed }
{ these speeds double when the high speed jumper is put in the upper}
{ position}
ADWordRate15     = $00000;
ADWordRate30     = $02000;
ADWordRate60     = $04000;
ADWordRate123    = $06000;
ADWordRate169    = $08000;
ADWordRate202    = $0A000;
ADWordRate3r76   = $0C000;
ADWordRate7r51   = $0E000;
ADUniPolar       = $01000;
ADRange100MV     = $00000;
ADRange50MV      = $00200; {actually 55mV but we treat it as 50}
ADRange25MV      = $00400;
ADRange1V        = $00600;
ADRange5V        = $00800;
ADRange2r5V      = $00A00;
ADPumpDisable    = $00100;
ADResetSystem    = $00080;
ADResetValid     = $00040;
ADPortFlag       = $00020;
ADPwrSave        = $00010;
ADDoneFlag       = $00008;
ADCCNormal       = $00000;
ADCCSelfOffset   = $00001;
ADCCSelfGain     = $00002;
ADCCSelfOffGain  = $00003;
ADCCSystemOffset = $00005;
ADCCSystemGain   = $00006;
